#!/bin/bash
# Skript k čištění starých kernelů. Aktuální + jeden starší ponechává.
# Dále vyčistí apt cache a staré konfig. soubory.
# Nejprve nutno nechat proběhnout odstranění OLDCONF!!

OLDCONF=$(dpkg -l|grep "^rc"|awk '{print $2}')
#LOWLAT=$(dpkg -l | grep lowlatency | sed -n '2p' | cut -c 19-31)

LOWLAT_NEWEST=$(dpkg -l | grep lowlatency | sed '$!d' | cut -c 19-31)

CURKERNEL=$(uname -r|sed 's/-*[a-z]//g'|sed 's/-386//g')
LINUXPKG="linux-(image|headers|modules|ubuntu-modules|modules-extra|restricted-modules|hwe)"
METALINUXPKG="linux-(image|headers|restricted-modules|)-(generic|i386|server|common|rt|xen)"

YELLOW="\033[1;33m"
RED="\033[0;31m"
ENDCOLOR="\033[0m"

echo -e $YELLOW"Seznam starých config souborů k odstranění:"$ENDCOLOR
echo $OLDCONF
echo
echo
echo -n -e "\e[41mChcete tyto položky odstranit (y/n)? \e[0m "
read answer
if [ "$answer" != "${answer#[Yy]}" ] ;then
    echo -e $YELLOW"Čištění apt cache..."$ENDCOLOR;
    sudo apt-get clean
    echo -e $YELLOW"Odstraňování starých config souborů..."$ENDCOLOR;
    sudo dpkg --purge $OLDCONF
    echo "Všechny položky byly odstraněny"
    sleep 3
else
    echo "Nebyla odstraněna žádná položka"
    sleep 3
fi
echo "----------------------------------------------------------"
echo "----------------------------------------------------------"
#OLDKERNELS=$(dpkg -l|awk '{print $2}'|grep -E $LINUXPKG |grep -vE $METALINUXPKG|grep -v $CURKERNEL)

#bez lowlat kernelů
OLDKERNELS=$(dpkg -l|awk '{print $2}'|grep -E $LINUXPKG |grep -vE $METALINUXPKG|grep -v $CURKERNEL|grep -v $LOWLAT_NEWEST|grep -v lowlatency-hwe-18.04)

echo -e $YELLOW"Seznam starých kernelů k odstranění:"$ENDCOLOR
echo $OLDKERNELS
echo
echo
echo -n -e "\e[41mChcete tyto položky odstranit (y/n)? \e[0m "
read answer
if [ "$answer" != "${answer#[Yy]}" ] ;then
    echo -e $YELLOW"Odstraňování starých kernelů..."$ENDCOLOR;
    sudo dpkg --purge $OLDKERNELS
    echo "Všechny položky byly odstraněny"
    echo "Will exit............"
    sleep 3
else
    echo "Nebyla odstraněna žádná položka"
    echo "Will exit............"
    sleep 2
fi

echo -e $YELLOW"Script ukončen!"$ENDCOLOR
sleep 2; exit
